#include <stdio.h>
#include <time.h>
#include "driver/mouse.h"
#include "driver/vga.h"
#include "api/jpeg_decoder.h"
#include "api/LCD.h"
#include <system.h>
#include <io.h>
#include <stdlib.h>

static enum
{
    STATE_INIT,
    STATE_GAME,
    STATE_END
}   GAME_STATE;

extern "C" void fat_loop_files();

extern "C"
{
    void show( );
    int init_file_system( );
    int mount_file_system( );
    const unsigned char * read_next_file( const char * ext, char * filename, int * size );
    void  LCD_Init();
    void  LCD_Show_Text(char* Text);
    void  LCD_Line2();
    void  LCD_Test();

}


void write_image( const int& sprite_id, const int& image_id );

void delay( int time )
{
    while( time-- );
}

int get_clicked_sprite_id( int position_x, int position_y )
{
    if ( position_x > 0 && position_x < 129 && position_y > 45 && position_y < 110 )
    {
        return 0;
    }
    if ( position_x > 170 && position_x < 299 && position_y > 45 && position_y < 110 )
    {
        return 1;
    }
    if ( position_x > 340 && position_x < 469 && position_y > 45 && position_y < 110 )
    {
        return 2;
    }
    if ( position_x > 510 && position_x < 639 && position_y > 45 && position_y < 110 )
    {
        return 3;
    }
    if ( position_x > 0 && position_x < 129 && position_y > 154 && position_y < 219 )
    {
        return 4;
    }
    if ( position_x > 170 && position_x < 299 && position_y > 154 && position_y < 219 )
    {
        return 5;
    }
    if ( position_x > 340 && position_x < 469 && position_y > 154 && position_y < 219 )
    { 
        return 6;
    }
    if ( position_x > 510 && position_x < 639 && position_y > 154 && position_y < 219 )
    {
        return 7;
    }
    if ( position_x > 0 && position_x < 129 && position_y > 263 && position_y < 328 )
    {
        return 8;
    }
    if ( position_x > 170 && position_x < 299 && position_y > 263 && position_y < 328 )
    {
        return 9;
    }
    if ( position_x > 340 && position_x < 469 && position_y > 263 && position_y < 328 )
    {
        return 10;
    }
    if ( position_x > 510 && position_x < 639 && position_y > 263 && position_y < 328 )
    {
        return 11;
    }
    if ( position_x > 0 && position_x < 129 && position_y > 372 && position_y < 437 )
    { 
        return 12;
    }
    if ( position_x > 170 && position_x < 299 && position_y > 372 && position_y < 437 )
    { 
        return 13;
    }
    if ( position_x > 340 && position_x < 469 && position_y > 372 && position_y < 437 )
    {
        return 14;
    }
    if ( position_x > 510 && position_x < 639 && position_y > 372 && position_y < 437 )
    { 
        return 15;
    }
    return -1;
}

extern "C" void write_sram( const int address, const int data );

void write_sram( const int address, const int data )
{
    IOWR_32DIRECT( SRAM_BASE, address * 4, data );
}

void shuffle_cards( int * random_array )
{
    int flag=0,value,index=0,i;
    //int random_array[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

    /* initialize random seed: */
    while(index <=15)
    {
        /* generate random number: */
        value= rand()%16+1;
        //printf( "value=%d  ",value);

        for(i=0;i<=index;i++)
        { 
            if(random_array[i]==value)
            {
                flag=1;
                break;
            }
        }

        if(flag==0)
        {
            random_array[index]=value;
            index++;
        }

        flag =0;

    }
    for( i =0; i<=15;i++)
    {
        random_array[i]--;
        random_array[i] /= 2;
    }

    for( i =0; i<=15;i++)
    {
        //printf("%d   ", random_array[i]);
    }
}

 
int main()
{
    printf("Hello from Nios II!\n");
//     void LCD_Test();
     LCD_Test();
    
    srand( IORD_32DIRECT( SDRAM_BASE, 0xF000 ) ); 
    
    char buf[ 100 ] = { 0, };
    int i = 0;
    sprintf( buf, "%d clicked", i );
    //LCD_Show_Text(buf);
    const unsigned int TIMEOUT = 0xFFFF;

    Mouse& m = Mouse::create( );
    Vga& v = Vga::create( );
    
    JPEG_Decoder d;
    
    m.init();
    v.set_resolution( 640, 480 );
    v.locate_cursor( 400, 400 );


/*
    char ext[ 4 ] = "JPG";
    char filename[ 100 ] = { 0, };
    int size = 0;
    
    
    init_file_system( );
    mount_file_system( );
    read_next_file( ext, filename, &size );
    printf( "name: %s, size: %d\n", filename, size );

    read_next_file( ext, filename, &size );
    printf( "name: %s, size: %d\n", filename, size );
//*/

//   for( int i = 0; i < 100; i++ )
//   {
//    printf( "BEFORE: %02X\n", IORD_8DIRECT( SRAM_BASE, i ) );
//   }
//   
//   for( int i = 0; i < 100; i++ )
//   {
//    IOWR_8DIRECT( SRAM_BASE, i, i );
//   }
//   
//   for( int i = 0; i < 100; i++ )
//   {
//    printf( "AFTER: %02X\n", IORD_8DIRECT( SRAM_BASE, i ) );
//   }   
//
//    return 0;

    v.show_back_image_all( );

    IOWR_32DIRECT( VGA_BASE, 0x0C, 0x00 );
    IOWR_32DIRECT( VGA_BASE, 0x08, 0xFFFFFFFF );

    //while( true )
    {
        fat_loop_files( );
    }

    IOWR_32DIRECT( VGA_BASE, 0x08, 0x00 );

//    for( int i = 0; i < 16; i++ )
//    {
//        write_image( i, i / 2 );
//    }

//
//    IOWR_32DIRECT( VGA_BASE, 0x0C, 0x7C );
//
//    IOWR_32DIRECT( VGA_BASE, 0x10, 0x00 );



//    int flag = 0;
//    while( true )
//    {
//        IOWR_32DIRECT( VGA_BASE, 0x0C, 0xFFFF );
//                
//        IOWR_32DIRECT( VGA_BASE, 0x10, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x14, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x18, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x1C, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x20, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x24, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x28, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x2C, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x30, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x34, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x38, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x3C, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x40, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x44, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x48, 0x00 );
//        IOWR_32DIRECT( VGA_BASE, 0x4C, 0x00 );
//        delay( 10000000 );
//        IOWR_32DIRECT( VGA_BASE, 0x10, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x14, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x18, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x1C, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x20, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x24, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x28, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x2C, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x30, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x34, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x38, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x3C, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x40, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x44, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x48, flag % 3 + 1 );
//        IOWR_32DIRECT( VGA_BASE, 0x4C, flag % 3 + 1 );
//        
//        flag++;
//        delay( 10000000 );
//        //IOWR_32DIRECT( VGA_BASE, 0x0C, 0x01007F );
//        //IOWR_32DIRECT( VGA_BASE, 0x14, 0x00 );
//        //delay( 100000 );
//        printf( " " );
//        //IOWR_32DIRECT( VGA_BASE, 0x14, 0x04 );
//        //delay( 6000000 );
//    }


    v.enter_read_mode( );
    //v.show_back_image( 0 );
    //v.show_front_image( 0 );
//    while( true )
//    {
//        v.turn_back_image( 7 );
//        v.turn_back_image( 11 );
//        v.turn_front_image( 7 );
//        v.turn_front_image( 11 );
//    }
//    v.turn_back_image( 0 );
//    v.turn_front_image( 0 );
//
//    while( true )
//    {
//        for( int i = 0; i < 16; i++ )
//        {
//            IOWR_32DIRECT( VGA_BASE, 0x0C, 0x00 );
//            delay( 10000000 );
//            IOWR_32DIRECT( VGA_BASE, 0x10 + 4 * i, 0x00 );
//            delay( 10000000 );
//            IOWR_32DIRECT( VGA_BASE, 0x10 + 4 * i, 0x01 );
//            delay( 10000000 );
//            IOWR_32DIRECT( VGA_BASE, 0x0C, 0x01 << i );
//            IOWR_32DIRECT( VGA_BASE, 0x10 + 4 * i, 0x01 );
//            delay( 10000000 );
//            IOWR_32DIRECT( VGA_BASE, 0x10 + 4 * i, 0x02 );
//            delay( 10000000 );
//        }
//    }

    // shuffle cards
    int random_array[ 16 ] = { 0, };
    shuffle_cards( random_array );
    // distribute cards
    for( int i = 0; i < 16; i++ )
    {
        write_image( i, random_array[ i ]  );
    }

    int turn = 0;
    int selected_sprite[ 2 ] = { -1, };
    bool matched[ 8 ] = { false, };
    int n_matched = 0;
    int state = STATE_GAME;
    while( true )
    {
        int dir_x = 0;
        int dir_y = 0;
        int pos_x = 0;
        int pos_y = 0;

        if( m.update( TIMEOUT ) )
        {
            m.get_direction( dir_x, dir_y );
            v.move_cursor( dir_x, dir_y );
            if( m.get_status( Mouse::LEFT ) == Mouse::PRESSED )
            {
                printf( "pressed\n" );
                switch( state )
                {
                    case STATE_INIT:
                    state = STATE_GAME;
                    v.show_back_image_all( );
                    for( int i = 0; i < 8; i++ )
                    {
                        matched[ i ] = false;
                    }
                    n_matched = 0;
                    // shuffle cards
                    shuffle_cards( random_array );
                    // distribute cards
                    for( int i = 0; i < 16; i++ )
                    {
                        write_image( i, random_array[ i ]  );
                    }
                    printf( "image loaded again" );
                    break;
                    case STATE_GAME:
                    // check whether it is same as previous or already matched
                    v.get_cursor_position( pos_x, pos_y );
                    if( selected_sprite[ 0 ] == get_clicked_sprite_id( pos_x, pos_y ) || matched[ random_array[ get_clicked_sprite_id( pos_x, pos_y ) ] ] )
                    {
                        continue;
                    }
                    
                    v.turn_back_image( get_clicked_sprite_id( pos_x, pos_y ) );
                    
                    // check whether it is first matching or second matching
                    if( turn == 0 )
                    {
                        turn++;
                        selected_sprite[ 0 ] = get_clicked_sprite_id( pos_x, pos_y );
                    }
                    else
                    {
                        // check matching
                        turn = 0;
                        if( random_array[ selected_sprite[ 0 ] ] == random_array[ get_clicked_sprite_id( pos_x, pos_y ) ] )
                        {
                            matched[ random_array[ selected_sprite[ 0 ] ] ] = true;
                            n_matched++;
                            v.fade_out_image( selected_sprite[ 0 ] );
                            v.fade_out_image( get_clicked_sprite_id( pos_x, pos_y ) );
                        }
                        else
                        {
                            delay( 7000000 );
                            v.turn_front_image( selected_sprite[ 0 ] );
                            v.turn_front_image( get_clicked_sprite_id( pos_x, pos_y ) );
                        }
                        selected_sprite[ 0 ] = -1;
                    }
                    
                    // end check
                    if( n_matched == 8 )
                    {
                        state = STATE_END;
                    }
                    break;
                    case STATE_END:
                    state = STATE_INIT;
                    break;
                }
            }
        }
        else
        {
            m.init( );
        }
    }
    
    return 0;
}
